/**********************************************************************************************/
/*                                                                                            */
/*                              .                               */
/*                                                                                            */
/**********************************************************************************************/
#ifndef TIMER_H
#define TIMER_H

#include  "../main/main.h"

#ifndef TIMER_DEFINE
#define TIMER_DEFINE

/*--------------------------------------------------------------------------------------------*/
/*   ,   .                                               */
/*        .                                   */
/*--------------------------------------------------------------------------------------------*/
typedef   void (*pTIMER_FUNC)(void);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                            */
/*--------------------------------------------------------------------------------------------*/
struct TIMER
{
  union                     //   .
    {
      BYTE Flags;
      struct
        {
          BYTE Timer_Ena    : 1,  // "1" -   ,
                                  // "0" -   / .
               Timer_Cycle  : 1;  // "1" -    ,
                                  // "0" -    .
        };
    };
  WORD          Interval;   //  .
  WORD          Counter;    //   .
  pTIMER_FUNC   pFunc;      //  .
};

/*--------------------------------------------------------------------------------------------*/
/*   /  .                                                        */
/*--------------------------------------------------------------------------------------------*/
#define   TIMER_ENA         true
#define   TIMER_DIS         false

/*--------------------------------------------------------------------------------------------*/
/*      /  .                               */
/*--------------------------------------------------------------------------------------------*/
#define   TIMER_CYCLE       true
#define   TIMER_ONCE        false

#endif

/*--------------------------------------------------------------------------------------------*/
/*   .                                                               */
/*--------------------------------------------------------------------------------------------*/
extern struct TIMER Timer[8];

/*--------------------------------------------------------------------------------------------*/
/*    .                                                */
/* :     .                                                          */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Sys_Timer_Init(void);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                                 */
/* :     (0 - 7),                                                        */
/*                   (1..56535),                                       */
/*                   ( NULL),                           */
/*                .                                                   */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Start_Timer(IN IDX timer, IN WORD interval, IN pTIMER_FUNC pFunc = NULL, IN bool cycle = TIMER_ONCE);

/*--------------------------------------------------------------------------------------------*/
/*   .                                                               */
/* :     (0 - 7).                                                        */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
void Stop_Timer(IN IDX timer);

/*--------------------------------------------------------------------------------------------*/
/*     .                                           */
/* :     (0 - 7).                                                        */
/* :  TRUE,   .                                                 */
/*--------------------------------------------------------------------------------------------*/
#define   is_Timer_Stopped(timer)   (Timer[(timer)].Timer_Ena != TIMER_ENA)

/*--------------------------------------------------------------------------------------------*/
/*    .                                               */
/* :       m.                                           */
/* :    .                                                         */
/*--------------------------------------------------------------------------------------------*/
#define   Pause(timer, delay)                   \
{                                               \
  Start_Timer((timer), (delay));                \
  while(!is_Timer_Stopped((timer))) __sleep();  \
}


/**********************************************************************************************/
#endif
